// This script gets you into the Spec/Unspec Temples using Hyssop (Malar).
//
// Change these settings to suit your character
var LogOnDeath = false;         // true will log off at the LS if you die.
var UseDelay = 1;               // time gap between attempts (in seconds)

var Version    = "2005.04.08.0"
var PluginName = "SMIncTemple"
var PluginShortName = PluginName.slice(5)

macroDir = skapi.szDirAC + "\\SMIncScripts\\"

alertAdminWav	= skapi.WavNew(macroDir+"broadcast.wav");	// Played when admin detected
alertAlertWav	= skapi.WavNew(macroDir+"alert1.wav");  	// Played when stealth mode activated
alertDeathWav	= skapi.WavNew(macroDir+"dead.wav");		// Sound to play when we die

alertPlayerWav	= skapi.WavNew(macroDir+"fellow.wav");  	// Played when another player detected
alertPortalWav	= skapi.WavNew(macroDir+"portal.wav");		// Played when avoiding portal
alertTellWav	= skapi.WavNew(macroDir+"patron.wav");		// Played when @tell message detected
alertDingWav	= skapi.WavNew(macroDir+"vassal.wav");		// Played when other chat message detected
alertBeepWav	= skapi.WavNew(macroDir+"beep.wav");		

// Internal Variables, change at own risk

//raw
var h = new myHandlers();
var Go;
var opmAll = (opmDebugLog | opmChatWnd | opmConsole);
var Start;
var szSchema;
var First = true;

//main
var StartPackCount = 0;        // Starter value for number of items in main pack
var OldPackCount = 0;          // Temporary value for number of items in main pack
var RunningClock;
var DebugFlag = false;
var DebugFlag2 = false;
var Hyssop;
var Hyssop1;
var TempleFound = false;
var TempleAco;
var TempleLoc;
var TempleUses = 0;
var PlayersSeen = 0;

function MyHandlers_OnControlEvent(szPanel, szControl, dictSzValue)
{
	var BoolCheck;
	if (szPanel == PluginName)
	{
		switch (szControl)
		{
		case 'chkDebugFlag':
			DebugFlag = (dictSzValue('chkDebugFlag')=="True");
                        SmincAmber();
			skapi.OutputLine("Edited: Option - DebugFlag now " + dictSzValue('chkDebugFlag'), opmAll);
			break;
		case 'chkDebugFlag2':
			DebugFlag2 = (dictSzValue('chkDebugFlag2')=="True");
                        SmincAmber();
			skapi.OutputLine("Edited: Option - DebugFlag2 now " + dictSzValue('chkDebugFlag2'), opmAll);
			break;

		case 'btnQuit':
			Go = false;
			break;

		default:
			break;
		}			  	
	}
}

function MyHandlers_OnTell(acoSender, acoReceiver, szMsg)
{
        if (DebugFlag) skapi.OutputLine("tell - sender : " + acoReceiver + " - receiver : " + acoSender, opmAll,6);
        if (DebugFlag2) skapi.OutputLine("tell - message : " + szMsg, opmAll,6);

	alertTellWav.Play();
}

function MyHandlers_OnChatBoxMessage(szMsg, cmc)
{
	if (DebugFlag) skapi.OutputLine("msg : " + szMsg + "cmc : " + cmc, opmChatWnd);

// Globals
        if ( cmc == 0 && (szMsg.indexOf("Turbine") > -1) )
            alertTellWav.Play();

// Death
	if ( cmc == 0 && ( (szMsg.indexOf("Your Corpse") > -1) || (szMsg.indexOf("You've lost") > -1) ) )	
            skapi.OutputLine(szMsg, opmConsole);

// Temple
        if ( cmc == 3 && (szMsg.indexOf("Bring me the essence of Malar") > -1) ) {
            alertDingWav.Play();
            UseHyssop();
        }

// Misc
        if ( cmc == 2 && (szMsg.indexOf("You say,") == -1) )
            alertTellWav.Play();
}

function MyHandlers_OnDeathSelf(acoKiller, szMsg)
{
        alertDeathWav.Play();

	skapi.OutputLine(Math.round(Start.cmsec/60000) + " mins - I died", opmAll);
	skapi.OutputLine(szMsg, opmAll);

	while (skapi.WaitEvent(1000,2,evidOnEndPortalSelf) != evidOnEndPortalSelf) {
            // just loop till done
		}
            skapi.WaitEvent(100,3);

	Go = false;
        return;
}

function MyHandlers_OnObjectCreatePlayer(aco)
{
	if (aco.szName == skapi.szName)
		return;

        var myloc      = skapi.maplocCur; // My current location
        var PlayerHead = Compass(myloc.HeadToMaploc(aco.maploc),3); // Get heading
        var PlayerDist = Math.round(myloc.Dist3DToMaploc(aco.maploc)*10)/10;

        if (DebugFlag) skapi.OutputLine("PlayerHead " + PlayerHead, opmChatWnd,8);
        if (DebugFlag) skapi.OutputLine("PlayerDist " + PlayerDist, opmChatWnd,8);

//      Player Alert

        alertPlayerWav.Play();
        PlayersSeen++;
        SmincRed();
        skapi.OutputLine(Math.round(Start.cmsec/60000) + " mins - " + "Player Detected, " + PlayerDist + " unit(s)  " + PlayerHead + "  - " + aco.szName + "  Total Players Seen =  " + PlayersSeen, opmChatWnd,4);
        skapi.WaitEvent(50,0);
}

function MyHandlers_OnEndPortalSelf()
{
        SmincGreen();
        skapi.OutputLine(Math.round(Start.cmsec/60000) + " mins - I just Portalled.", opmChatWnd);

        Go = false;
        return;
}

function MyHandlers_OnActionComplete()
{
        if (DebugFlag) skapi.OutputLine("OnActionComplete", opmChatWnd);
        LastActionComplete = Start.cmsec/1000;
}


function myHandlers()
{
 	this.OnControlEvent = MyHandlers_OnControlEvent;
 	this.OnTell = MyHandlers_OnTell;
 	this.OnChatBoxMessage = MyHandlers_OnChatBoxMessage;
 	this.OnDeathSelf = MyHandlers_OnDeathSelf;
 	this.OnEndPortalSelf = MyHandlers_OnEndPortalSelf;
 	this.OnActionComplete = MyHandlers_OnActionComplete;
}
 
function fAddHandlers()
{
 	skapi.AddHandler(evidOnControlEvent,h);
 	skapi.AddHandler(evidOnTell,h);
 	skapi.AddHandler(evidOnChatBoxMessage,h);
 	skapi.AddHandler(evidOnDeathSelf,h);
 	skapi.AddHandler(evidOnEndPortalSelf,h);
 	skapi.AddHandler(evidOnActionComplete,h);
} 
 
function fRemoveHandlers()
{
 	skapi.RemoveHandler(evidOnControlEvent,h);
 	skapi.RemoveHandler(evidOnTell,h);
 	skapi.RemoveHandler(evidOnChatBoxMessage,h);
 	skapi.RemoveHandler(evidOnDeathSelf,h);
 	skapi.RemoveHandler(evidOnEndPortalSelf,h);
 	skapi.RemoveHandler(evidOnActionComplete,h);
}

function UseTemple()
{
        if ( TempleAco == null ) {
            TempleAco = FindTemple();
            TempleLoc = TempleAco.maploc;
            if (DebugFlag) skapi.OutputLine("TempleLoc " + TempleLoc, opmChatWnd);
        }

        var myloc= skapi.maplocCur; // My current location

        if (myloc.Dist3DToMaploc(TempleLoc) > 0.02 ) {
            if (DebugFlag) skapi.OutputLine("While Move : " + Math.round(TempleLoc.Dist3DToMaploc(skapi.maplocCur)*1000)/1000, opmChatWnd);
            skapi.GoToMaploc(TempleLoc, 0.02, true, true, 5000);
            skapi.WaitEvent(5000,3);
            skapi.SelectAco(TempleAco);
        }

        TempleAco.Use();
        TempleUses++;

        var useszero = "";
        if ( TempleUses < 10)
            useszero = "0"

        skapi.SetControlProperty(PluginName, "statUses", "text", useszero + TempleUses)
        skapi.WaitEvent(UseDelay*1000,3);
}

function UseHyssop()
{
        Hyssop1 = skapi.AcoFindInInv("Hyssop");
        skapi.SelectAco(Hyssop1);
        skapi.SetStackCount(1);

        skapi.SelectAco(TempleAco);
	skapi.OutputLine("Using Hyssop", opmAll);
        Hyssop1.MoveToStack(TempleAco);
        skapi.WaitEvent(UseDelay*1000,3);

	while (skapi.WaitEvent(1000,2,evidOnEndPortalSelf) != evidOnEndPortalSelf) {
            // just loop till done
	}
	skapi.WaitEvent(100,3);
}

function FindTemple()
{
                var Temples = skapi.CoacoNew();             // Empty  collection
                var FilterTemples = skapi.AcfNew();         // Init  filter

                FilterTemples.szName = "Guardian of the Temple *";
                FilterTemples.distMax = 0.05;		   // Max distance to check
                Temples = FilterTemples.CoacoGet();
                Temples.Sort(skapi.sortbyDist);
                TempleFound = true;

                if (DebugFlag) skapi.OutputLine("Found "+Temples.Count+" Temple(s).",opmChatWnd,5);
                skapi.SetControlProperty(PluginName, "chkTempleFound", "checked", TempleFound)
        	var CurrentTemple = Temples.Item(0);
                return CurrentTemple;
}

function SmincGreen()
{
//      yellow - green - yellow
 	skapi.OutputSz("<", opmChatWnd,4);
 	skapi.OutputSz(PluginShortName, opmChatWnd,0);
 	skapi.OutputSz("> ", opmChatWnd,4);
}

function SmincAmber()
{
//      orange - yellow - orange
 	skapi.OutputSz("<", opmChatWnd,22);
 	skapi.OutputSz(PluginShortName, opmChatWnd,4);
 	skapi.OutputSz("> ", opmChatWnd,22);
}

function SmincRed()
{
//      yellow - red - yellow
 	skapi.OutputSz("<", opmChatWnd,4);
 	skapi.OutputSz(PluginShortName, opmChatWnd,6);
 	skapi.OutputSz("> ", opmChatWnd,4);
}

function FmtNbr(nbr) { // Return a comma formatted string for a number
     var fstr="", str=nbr.toFixed(0), len= nbr<0 ? 4 : 3;
     while(str.length>len) {     // Is another comma needed?
          fstr= ","+str.slice(-3)+fstr;
          str= str.slice(0,-3);     // Remove the last 3 digits
     }
     return str+fstr;
} 

function FmtTime(Time) { // Return a comma formatted string for a number
     var Hours = Math.floor(Time/60);
     var Mins = Math.round(((Time/60)-Hours) * 60);
     return Hours + " Hours " + Mins + " Mins";
} 

function Compass(heading,detail) { // Convert heading to compass direction
	var str="", dir= Math.floor(heading/45*4);
	switch(detail) {
	case 3:
		if((dir+1)&2) {			// 3-char direction?
			str= "NESW".charAt(((dir+5)>>3)&3); // Add modifier
			dir= (dir&~4)|2;	// Force next direction range
		}
	default:
	case 2:
		if((dir+2)&4) {			// Mixed direction?
			str += (dir+10)&16 ? "S" : "N"; // Add modifier
			dir= (dir&~8)|4;	// Force next direction range
		}
	case 1:
		str += "NESW".charAt(((dir+4)>>3)&3); // Set main direction
	}
	return str;
}


function Initialise()
{
 	skapi.OutputLine(PluginName + "  v " + Version + " - Begin Macro" , opmAll,13);
 	skapi.OutputLine("Welcome " + skapi.szName , opmAll,13);

 	SetupSchema();
 	skapi.ShowControls(szSchema, First);
 	Go = true;

        RunningClock = Start.cmsec;
        LastActionComplete = Start.cmsec/1000;

        TempleCheck = skapi.AcfNew();       // quick temple look
        TempleCheck.szName = "Guardian of the Temple *";
        TempleCheck.distMax = 0.05;

        skapi.SetControlProperty(PluginName, "statTemples", "text", "-")
        skapi.SetControlProperty(PluginName, "statHyssop", "text", "-")
        skapi.SetControlProperty(PluginName, "statUses", "text", "-")

        Hyssop = skapi.CitemOfKindInInv("Hyssop");
        skapi.SetControlProperty(PluginName, "statHyssop", "text", Hyssop)

 	skapi.OutputLine("Date : " + Date(), opmAll,14);
 	skapi.OutputLine("Current Location : " + skapi.maplocCur.sz + "      Heading : " + Math.round(skapi.maplocCur.head) + " degrees", opmAll,14);
}

function main() 
{ 	
	var KeepRunning = true;
	var LoggedTime = skapi.TimerNew();
	var LogTime = 0;
        Start = skapi.TimerNew();

	fAddHandlers();
	while (KeepRunning)
	{
		Initialise();
		while (Go)
		{
		var e;
		try {
                        if (DebugFlag) {
                            skapi.OutputLine("Cycle " + Math.round((Start.cmsec - RunningClock)/10)/100 + " seconds" , opmChatWnd,5);
                            skapi.OutputLine("LastActionComplete : " + Math.round(Start.cmsec/1000 - LastActionComplete) + " seconds.", opmChatWnd,9);
                            RunningClock = Start.cmsec;
                        }

                        if ( Hyssop == 0 ) {
                            SmincRed();
                            skapi.OutputLine(Math.round(Start.cmsec/60000) + " mins - No Hyssop in Inventory, exiting script." , opmAll,6);
                            Go = false;
                            skapi.WaitEvent(1000,3);
                        }

			if ( Go && (TempleCheck.AcoGet() == null && !TempleFound ) ) {
                            SmincRed();
                            skapi.OutputLine("No Temples in Range, exiting script." , opmAll,6);
                            Go = false;
                            skapi.WaitEvent(1000,3);
                        }    

			if ( Go ) {
                            if (DebugFlag) skapi.OutputLine("1 - Temple ", opmChatWnd,11);
                            UseTemple();
			}
                        skapi.WaitEvent(100,0);

                    }
		catch (e)
                    {
			if (skapi.plig == pligNotRunning) {
                            Go = false;
			}
                    }
		}
		First = false;
 		skapi.RemoveControls(PluginName);
		KeepRunning = false;
 	}
 	fRemoveHandlers();
        SmincRed();
 	skapi.OutputLine(Math.round(Start.cmsec/60000) + " mins - " + PluginName + "  v " + Version + " - End Macro" , opmAll);
}
 
  function SetupSchema()
  {
  szSchema =
  	"<view icon='10661' title='" + PluginName + "' \n" + 
  	"  width='180' height='243'>\n" + 
  	"  <control progid='DecalControls.FixedLayout'>\n" + 
  	"        <control name='edtSpacer' progid='DecalControls.Edit' text='' left='10' top='4' width='160' height='1' imageportalsrc='1291' />\n" +

        "        <control name='txtIns' progid='DecalControls.StaticText' text='This script uses Hyssop to' left='10' top='15' width='160' height='20' fontsize='14' fontstyle='bold' textcolor='65535' />\n" +
        "        <control name='txtIns' progid='DecalControls.StaticText' text='enter Spec/Unspec Temples.' left='10' top='30' width='165' height='20' fontsize='14' fontstyle='bold' textcolor='65535' />\n" +
        "        <control name='txtIns' progid='DecalControls.StaticText' text='Stand close to the Temple' left='10' top='50' width='165' height='20' fontstyle='bold' />\n" +
        "        <control name='txtIns' progid='DecalControls.StaticText' text='and start the script.' left='10' top='65' width='165' height='20' fontstyle='bold' />\n" +

  	"        <control name='edtSpacer' progid='DecalControls.Edit' text='' left='10' top='84' width='160' height='1' imageportalsrc='1291' />\n" +

  	"        <control name='txtTemples' progid='DecalControls.StaticText' text='Temple Found' left='10' top='90' width='140' height='20' />\n" +
  	"        <control name='txtHyssop' progid='DecalControls.StaticText' text='Number of Hyssop' left='10' top='110' width='140' height='20' />\n" +
  	"        <control name='txtUses' progid='DecalControls.StaticText' text='Number of Temple uses' left='10' top='130' width='140' height='20' />\n" +

  	"        <control name='chkTempleFound' progid='DecalControls.CheckBox' text='' left='152' top='90' width='15' height='20' checked='" + TempleFound + "' />\n" +
  	"        <control name='statHyssop' progid='DecalControls.Edit' text='' left='150' top='110' width='18' height='16' imageportalsrc='1291' textcolor='65280' />\n" +
  	"        <control name='statUses' progid='DecalControls.Edit' text='' left='150' top='130' width='18' height='16' imageportalsrc='1291' textcolor='65535' />\n" +

  	"        <control name='edtSpacer' progid='DecalControls.Edit' text='' left='10' top='149' width='160' height='1' imageportalsrc='1291' />\n" +

  	"        <control name='chkDebugFlag' progid='DecalControls.CheckBox' text='Debug' left='105' top='155' width='70' height='20' checked='" + DebugFlag + "' />\n" +
  	"        <control name='chkDebugFlag2' progid='DecalControls.CheckBox' text='' left='155' top='155' width='15' height='20' checked='" + DebugFlag2 + "' />\n" +
  	"        <control name='edtSpacer' progid='DecalControls.Edit' text='' left='10' top='174' width='160' height='1' imageportalsrc='1291' />\n" +

  	"        <control name='txtVer' progid='DecalControls.StaticText' text='v " + Version.slice(3,13) + "' left='10' top='188' width='70' height='20' textcolor='16777215' />\n" +

// colours : red : 255 	Green : 65280  Blue : 16711680 	Black : 0  White : 16777215  Magenta : 16711935  Cyan : 16776960  Yellow : 65535
// colours : Orange : 33023  Pale Yellow : 12648447  Deep Purple : 12583104  Dark Purple : 4194432  Teal : 13684808  Dark orange : 29414    Brown : 16512   Dark Brown : 12386

  	"      <control name='btnQuit'  progid='DecalControls.PushButton' text='Quit' left='105' top='183' width='65' height='20' />\n" + 
  	"  </control>\n" + 
 	"</view>";
}
